Index: drivers/filesystems/btrfs/read.c
===================================================================
--- drivers/filesystems/btrfs/read.c	(révision 75772)
+++ drivers/filesystems/btrfs/read.c	(copie de travail)
@@ -45,1462 +45,334 @@
     chunk* c;
     UINT64 address;
     UINT32 buflen;
-    UINT64 num_stripes;
-    LONG stripes_left;
+    LONG num_stripes, stripes_left;
     UINT64 type;
     UINT32 sector_size;
-    UINT16 firstoff, startoffstripe, sectors_per_stripe, stripes_cancel;
+    UINT16 firstoff, startoffstripe, sectors_per_stripe;
     UINT32* csum;
     BOOL tree;
-    BOOL check_nocsum_parity;
     read_data_stripe* stripes;
-    KSPIN_LOCK spin_lock;
+    UINT8* va;
 } read_data_context;
 
 extern BOOL diskacc;
-extern tPsUpdateDiskCounters PsUpdateDiskCounters;
-extern tCcCopyReadEx CcCopyReadEx;
+extern tPsUpdateDiskCounters fPsUpdateDiskCounters;
+extern tCcCopyReadEx fCcCopyReadEx;
+extern tFsRtlUpdateDiskCounters fFsRtlUpdateDiskCounters;
 
-static NTSTATUS STDCALL read_data_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr) {
+#define LINUX_PAGE_SIZE 4096
+
+_Function_class_(IO_COMPLETION_ROUTINE)
+#ifdef __REACTOS__
+static NTSTATUS NTAPI read_data_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr) {
+#else
+static NTSTATUS read_data_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr) {
+#endif
     read_data_stripe* stripe = conptr;
     read_data_context* context = (read_data_context*)stripe->context;
-    UINT64 i;
-    LONG stripes_left;
-    KIRQL irql;
 
-    KeAcquireSpinLock(&context->spin_lock, &irql);
-    
-    stripes_left = InterlockedDecrement(&context->stripes_left);
-    
-    if (stripe->status == ReadDataStatus_Cancelling) {
-        stripe->status = ReadDataStatus_Cancelled;
-        goto end;
-    }
-    
+    UNUSED(DeviceObject);
+
     stripe->iosb = Irp->IoStatus;
-    
-    if (NT_SUCCESS(Irp->IoStatus.Status)) {
-        if (context->type == BLOCK_FLAG_DUPLICATE) {
-            stripe->status = ReadDataStatus_Success;
 
-            if (stripes_left > 0 && stripes_left == context->stripes_cancel) {
-                for (i = 0; i < context->num_stripes; i++) {
-                    if (context->stripes[i].status == ReadDataStatus_Pending) {
-                        context->stripes[i].status = ReadDataStatus_Cancelling;
-                        IoCancelIrp(context->stripes[i].Irp);
-                    }
-                }
-            }
-        } else if (context->type == BLOCK_FLAG_RAID0) {
-            stripe->status = ReadDataStatus_Success;
-        } else if (context->type == BLOCK_FLAG_RAID10) {
-            stripe->status = ReadDataStatus_Success;
-            
-            if (stripes_left > 0 && context->stripes_cancel != 0) {
-                for (i = 0; i < context->num_stripes; i++) {
-                    if (context->stripes[i].status == ReadDataStatus_Pending && context->stripes[i].stripenum == stripe->stripenum) {
-                        context->stripes[i].status = ReadDataStatus_Cancelling;
-                        IoCancelIrp(context->stripes[i].Irp);
-                        break;
-                    }
-                }
-            }
-        } else if (context->type == BLOCK_FLAG_RAID5) {
-            stripe->status = ReadDataStatus_Success;
-            
-            if (stripes_left > 0 && stripes_left == context->stripes_cancel && (context->csum || context->tree || !context->check_nocsum_parity)) {
-                for (i = 0; i < context->num_stripes; i++) {
-                    if (context->stripes[i].status == ReadDataStatus_Pending) {
-                        context->stripes[i].status = ReadDataStatus_Cancelling;
-                        IoCancelIrp(context->stripes[i].Irp);
-                        break;
-                    }
-                }
-            }
-        } else if (context->type == BLOCK_FLAG_RAID6) {
-            stripe->status = ReadDataStatus_Success;
+    if (NT_SUCCESS(Irp->IoStatus.Status))
+        stripe->status = ReadDataStatus_Success;
+    else
+        stripe->status = ReadDataStatus_Error;
 
-            if (stripes_left > 0 && stripes_left == context->stripes_cancel && (context->csum || context->tree || !context->check_nocsum_parity)) {
-                for (i = 0; i < context->num_stripes; i++) {
-                    if (context->stripes[i].status == ReadDataStatus_Pending) {
-                        context->stripes[i].status = ReadDataStatus_Cancelling;
-                        IoCancelIrp(context->stripes[i].Irp);
-                    }
-                }
-            }
-        }
-            
-        goto end;
-    } else {
-        stripe->status = ReadDataStatus_Error;
-    }
-    
-end:
-    KeReleaseSpinLock(&context->spin_lock, irql);
-    
-    if (stripes_left == 0)
+    if (InterlockedDecrement(&context->stripes_left) == 0)
         KeSetEvent(&context->Event, 0, FALSE);
 
     return STATUS_MORE_PROCESSING_REQUIRED;
 }
 
-static void raid5_reconstruct(UINT64 off, UINT32 skip, read_data_context* context, CHUNK_ITEM* ci, UINT64* stripeoff, UINT64 maxsize,
-                              BOOL first, UINT32 firststripesize, UINT16 missing) {
-    UINT16 parity, stripe;
-    UINT32 stripelen = first ? firststripesize : ci->stripe_length;
-    UINT32 readlen;
-    
-    TRACE("(%llx, %x, %p, %p, %llx, %llx, %u, %x, %x)\n", off, skip, context, ci, *stripeoff, maxsize, first, firststripesize, missing);
-    
-    parity = ((off / ((ci->num_stripes - 1) * ci->stripe_length)) + ci->num_stripes - 1) % ci->num_stripes;
-    
-    readlen = min(min(ci->stripe_length - (skip % ci->stripe_length), stripelen), maxsize - *stripeoff);
-    
-    if (missing != parity) {
-        UINT16 firststripe = missing == 0 ? 1 : 0;
-        
-        RtlCopyMemory(&context->stripes[missing].buf[*stripeoff], &context->stripes[firststripe].buf[*stripeoff], readlen);
-        
-        for (stripe = firststripe + 1; stripe < context->num_stripes; stripe++) {
-            if (stripe != missing)
-                do_xor(&context->stripes[missing].buf[*stripeoff], &context->stripes[stripe].buf[*stripeoff], readlen);
-        }
-    } else
-        TRACE("parity == missing == %x, skipping\n", parity);
-    
-    *stripeoff += stripelen;
-}
-
-static void raid5_decode(UINT64 off, UINT32 skip, read_data_context* context, CHUNK_ITEM* ci, UINT64* stripeoff, UINT8* buf,
-                         UINT32* pos, UINT32 length, UINT32 firststripesize) {
-    UINT16 parity, stripe;
-    BOOL first = *pos == 0;
-    UINT32 stripelen = first ? firststripesize : ci->stripe_length;
-    
-    parity = ((off / ((ci->num_stripes - 1) * ci->stripe_length)) + ci->num_stripes - 1) % ci->num_stripes;
-    
-    stripe = (parity + 1) % ci->num_stripes;
-    
-    while (TRUE) {
-        if (stripe == parity) {
-            *stripeoff += stripelen;
-            return;
-        }
-        
-        if (skip >= ci->stripe_length) {
-            skip -= ci->stripe_length;
-        } else {
-            UINT32 copylen = min(ci->stripe_length - skip, length - *pos);
-            
-            RtlCopyMemory(buf + *pos, &context->stripes[stripe].buf[*stripeoff + skip - ci->stripe_length + stripelen], copylen);
-            
-            *pos += copylen;
-            
-            if (*pos == length)
-                return;
-            
-            skip = 0;
-        }
-        
-        stripe = (stripe + 1) % ci->num_stripes;
-    }
-}
-
-static BOOL raid5_decode_with_checksum(UINT64 off, UINT32 skip, read_data_context* context, CHUNK_ITEM* ci, UINT64* stripeoff, UINT8* buf,
-                                       UINT32* pos, UINT32 length, UINT32 firststripesize, UINT32* csum, UINT32 sector_size) {
-    UINT16 parity, stripe;
-    BOOL first = *pos == 0;
-    UINT32 stripelen = first ? firststripesize : ci->stripe_length;
-    
-    parity = ((off / ((ci->num_stripes - 1) * ci->stripe_length)) + ci->num_stripes - 1) % ci->num_stripes;
-    
-    stripe = (parity + 1) % ci->num_stripes;
-    
-    while (TRUE) {
-        if (stripe == parity) {
-            *stripeoff += stripelen;
-            return TRUE;
-        }
-        
-        if (skip >= ci->stripe_length) {
-            skip -= ci->stripe_length;
-        } else {
-            UINT32 i;
-            UINT32 copylen = min(ci->stripe_length - skip, length - *pos);
-            
-            RtlCopyMemory(buf + *pos, &context->stripes[stripe].buf[*stripeoff + skip - ci->stripe_length + stripelen], copylen);
-            
-            for (i = 0; i < copylen / sector_size; i ++) {
-                UINT32 crc32 = ~calc_crc32c(0xffffffff, buf + *pos + (i * sector_size), sector_size);
-                
-                if (crc32 != csum[i]) {
-                    UINT16 j, firststripe = stripe == 0 ? 1 : 0;
-                    
-                    RtlCopyMemory(buf + *pos + (i * sector_size),
-                                  &context->stripes[firststripe].buf[*stripeoff + skip - ci->stripe_length + stripelen + (i * sector_size)], sector_size);
-                    
-                    for (j = firststripe + 1; j < ci->num_stripes; j++) {
-                        if (j != stripe) {
-                            do_xor(buf + *pos + (i * sector_size), &context->stripes[j].buf[*stripeoff + skip - ci->stripe_length + stripelen + (i * sector_size)], sector_size);
-                        }
-                    }
-                    
-                    crc32 = ~calc_crc32c(0xffffffff, buf + *pos + (i * sector_size), sector_size);
-                    
-                    if (crc32 != csum[i]) {
-                        ERR("unrecoverable checksum error\n");
-                        return FALSE;
-                    }
-                    
-                    RtlCopyMemory(&context->stripes[stripe].buf[*stripeoff + skip - ci->stripe_length + stripelen + (i * sector_size)], buf + *pos + (i * sector_size), sector_size);
-                    context->stripes[stripe].rewrite = TRUE;
-                }
-            }
-            
-            *pos += copylen;
-            
-            if (*pos == length)
-                return TRUE;
-            
-            skip = 0;
-        }
-        
-        stripe = (stripe + 1) % ci->num_stripes;
-    }
-    
-    return FALSE;
-}
-
-static BOOL raid5_decode_with_checksum_metadata(UINT64 addr, UINT64 off, UINT32 skip, read_data_context* context, CHUNK_ITEM* ci, UINT64* stripeoff, UINT8* buf,
-                                                UINT32* pos, UINT32 length, UINT32 firststripesize, UINT32 node_size) {
-    UINT16 parity, stripe;
-    BOOL first = *pos == 0;
-    UINT32 stripelen = first ? firststripesize : ci->stripe_length;
-    
-    parity = ((off / ((ci->num_stripes - 1) * ci->stripe_length)) + ci->num_stripes - 1) % ci->num_stripes;
-    
-    stripe = (parity + 1) % ci->num_stripes;
-    
-    while (TRUE) {
-        if (stripe == parity) {
-            *stripeoff += stripelen;
-            return TRUE;
-        }
-        
-        if (skip >= ci->stripe_length) {
-            skip -= ci->stripe_length;
-        } else {
-            UINT32 copylen = min(ci->stripe_length - skip, length - *pos);
-            tree_header* th = (tree_header*)buf;
-            UINT32 crc32;
-            
-            RtlCopyMemory(buf + *pos, &context->stripes[stripe].buf[*stripeoff + skip - ci->stripe_length + stripelen], copylen);
-            
-            crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, node_size - sizeof(th->csum));
-            
-            if (addr != th->address || crc32 != *((UINT32*)th->csum)) {
-                UINT16 j, firststripe = stripe == 0 ? 1 : 0;
-                
-                RtlCopyMemory(buf + *pos, &context->stripes[firststripe].buf[*stripeoff + skip - ci->stripe_length + stripelen], copylen);
-                
-                for (j = firststripe + 1; j < ci->num_stripes; j++) {
-                    if (j != stripe) {
-                        do_xor(buf + *pos, &context->stripes[j].buf[*stripeoff + skip - ci->stripe_length + stripelen], copylen);
-                    }
-                }
-                
-                crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, node_size - sizeof(th->csum));
-                
-                if (addr != th->address || crc32 != *((UINT32*)th->csum)) {
-                    ERR("unrecoverable checksum error\n");
-                    return FALSE;
-                }
-            }
-            
-            RtlCopyMemory(&context->stripes[stripe].buf[*stripeoff + skip - ci->stripe_length + stripelen], buf + *pos, copylen);
-            context->stripes[stripe].rewrite = TRUE;
-            
-            *pos += copylen;
-            
-            if (*pos == length)
-                return TRUE;
-            
-            skip = 0;
-        }
-        
-        stripe = (stripe + 1) % ci->num_stripes;
-    }
-    
-    return FALSE;
-}
-
-static void raid6_reconstruct1(UINT64 off, UINT32 skip, read_data_context* context, CHUNK_ITEM* ci, UINT64* stripeoff, UINT64 maxsize,
-                               BOOL first, UINT32 firststripesize, UINT16 missing) {
-    UINT16 parity1, parity2, stripe;
-    UINT32 stripelen = first ? firststripesize : ci->stripe_length;
-    UINT32 readlen;
-    
-    TRACE("(%llx, %x, %p, %p, %llx, %llx, %u, %x, %x)\n", off, skip, context, ci, *stripeoff, maxsize, first, firststripesize, missing);
-    
-    parity1 = ((off / ((ci->num_stripes - 2) * ci->stripe_length)) + ci->num_stripes - 2) % ci->num_stripes;
-    parity2 = (parity1 + 1) % ci->num_stripes;
-    
-    readlen = min(min(ci->stripe_length - (skip % ci->stripe_length), stripelen), maxsize - *stripeoff);
-    
-    if (missing != parity1 && missing != parity2) {
-        RtlCopyMemory(&context->stripes[missing].buf[*stripeoff], &context->stripes[parity1].buf[*stripeoff], readlen);
-        stripe = parity1 == 0 ? (ci->num_stripes - 1) : (parity1 - 1);
-        
-        do {
-            if (stripe != missing)
-                do_xor(&context->stripes[missing].buf[*stripeoff], &context->stripes[stripe].buf[*stripeoff], readlen);
-            
-            stripe = stripe == 0 ? (ci->num_stripes - 1) : (stripe - 1);
-        } while (stripe != parity2);
-    } else
-        TRACE("skipping parity stripe\n");
-    
-    *stripeoff += stripelen;
-}
-
-static void raid6_reconstruct2(UINT64 off, UINT32 skip, read_data_context* context, CHUNK_ITEM* ci, UINT64* stripeoff, UINT64 maxsize,
-                               BOOL first, UINT32 firststripesize, UINT16 missing1, UINT16 missing2) {
-    UINT16 parity1, parity2, stripe;
-    UINT32 stripelen = first ? firststripesize : ci->stripe_length;
-    UINT32 readlen = min(min(ci->stripe_length - (skip % ci->stripe_length), stripelen), maxsize - *stripeoff);
-    
-    TRACE("(%llx, %x, %p, %p, %llx, %llx, %u, %x, %x, %x)\n", off, skip, context, ci, *stripeoff, maxsize,
-          first, firststripesize, missing1, missing2);
-    
-    parity1 = ((off / ((ci->num_stripes - 2) * ci->stripe_length)) + ci->num_stripes - 2) % ci->num_stripes;
-    parity2 = (parity1 + 1) % ci->num_stripes;
-    
-    // skip if missing stripes are p and q
-    if ((parity1 == missing1 && parity2 == missing2) || (parity1 == missing2 && parity2 == missing1)) {
-        *stripeoff += stripelen;
-        return;
-    }
-    
-    if (missing1 == parity2 || missing2 == parity2) { // reconstruct from p and data
-        UINT16 missing = missing1 == parity2 ? missing2 : missing1;
-        
-        RtlCopyMemory(&context->stripes[missing].buf[*stripeoff], &context->stripes[parity1].buf[*stripeoff], readlen);
-        stripe = parity1 == 0 ? (ci->num_stripes - 1) : (parity1 - 1);
-        
-        do {
-            if (stripe != missing)
-                do_xor(&context->stripes[missing].buf[*stripeoff], &context->stripes[stripe].buf[*stripeoff], readlen);
-            
-            stripe = stripe == 0 ? (ci->num_stripes - 1) : (stripe - 1);
-        } while (stripe != parity2);
-    } else if (missing1 == parity1 || missing2 == parity1) { // reconstruct from q and data
-        UINT16 missing = missing1 == parity1 ? missing2 : missing1;
-        UINT16 i, div;
-        
-        stripe = parity1 == 0 ? (ci->num_stripes - 1) : (parity1 - 1);
-        
-        i = ci->num_stripes - 3;
-        
-        if (stripe == missing) {
-            RtlZeroMemory(&context->stripes[missing].buf[*stripeoff], readlen);
-            div = i;
-        } else
-            RtlCopyMemory(&context->stripes[missing].buf[*stripeoff], &context->stripes[stripe].buf[*stripeoff], readlen);
-        
-        stripe = stripe == 0 ? (ci->num_stripes - 1) : (stripe - 1);
-        
-        i--;
-        do {
-            galois_double(&context->stripes[missing].buf[*stripeoff], readlen);
-            
-            if (stripe != missing)
-                do_xor(&context->stripes[missing].buf[*stripeoff], &context->stripes[stripe].buf[*stripeoff], readlen);
-            else
-                div = i;
-            
-            stripe = stripe == 0 ? (ci->num_stripes - 1) : (stripe - 1);
-            i--;
-        } while (stripe != parity2);
-        
-        do_xor(&context->stripes[missing].buf[*stripeoff], &context->stripes[parity2].buf[*stripeoff], readlen);
-        
-        if (div != 0)
-            galois_divpower(&context->stripes[missing].buf[*stripeoff], div, readlen);
-    } else { // reconstruct from p and q
-        UINT16 x, y, i;
-        UINT8 gyx, gx, denom, a, b, *p, *q, *pxy, *qxy;
-        UINT32 j;
-        
-        stripe = parity1 == 0 ? (ci->num_stripes - 1) : (parity1 - 1);
-        
-        // put qxy in missing1
-        // put pxy in missing2
-        
-        i = ci->num_stripes - 3;
-        if (stripe == missing1 || stripe == missing2) {
-            RtlZeroMemory(&context->stripes[missing1].buf[*stripeoff], readlen);
-            RtlZeroMemory(&context->stripes[missing2].buf[*stripeoff], readlen);
-            
-            if (stripe == missing1)
-                x = i;
-            else
-                y = i;
-        } else {
-            RtlCopyMemory(&context->stripes[missing1].buf[*stripeoff], &context->stripes[stripe].buf[*stripeoff], readlen);
-            RtlCopyMemory(&context->stripes[missing2].buf[*stripeoff], &context->stripes[stripe].buf[*stripeoff], readlen);
-        }
-        
-        stripe = stripe == 0 ? (ci->num_stripes - 1) : (stripe - 1);
-        
-        i--;
-        do {
-            galois_double(&context->stripes[missing1].buf[*stripeoff], readlen);
-            
-            if (stripe != missing1 && stripe != missing2) {
-                do_xor(&context->stripes[missing1].buf[*stripeoff], &context->stripes[stripe].buf[*stripeoff], readlen);
-                do_xor(&context->stripes[missing2].buf[*stripeoff], &context->stripes[stripe].buf[*stripeoff], readlen);
-            } else if (stripe == missing1)
-                x = i;
-            else if (stripe == missing2)
-                y = i;
-            
-            stripe = stripe == 0 ? (ci->num_stripes - 1) : (stripe - 1);
-            i--;
-        } while (stripe != parity2);
-        
-        gyx = gpow2(y > x ? (y-x) : (255-x+y));
-        gx = gpow2(255-x);
-
-        denom = gdiv(1, gyx ^ 1);
-        a = gmul(gyx, denom);
-        b = gmul(gx, denom);
-        
-        p = &context->stripes[parity1].buf[*stripeoff];
-        q = &context->stripes[parity2].buf[*stripeoff];
-        pxy = &context->stripes[missing2].buf[*stripeoff];
-        qxy = &context->stripes[missing1].buf[*stripeoff]; 
-        
-        for (j = 0; j < readlen; j++) {
-            *qxy = gmul(a, *p ^ *pxy) ^ gmul(b, *q ^ *qxy);
-            
-            p++;
-            q++;
-            pxy++;
-            qxy++;
-        }
-        
-        do_xor(&context->stripes[missing2].buf[*stripeoff], &context->stripes[missing1].buf[*stripeoff], readlen);
-        do_xor(&context->stripes[missing2].buf[*stripeoff], &context->stripes[parity1].buf[*stripeoff], readlen);
-    }
-    
-    *stripeoff += stripelen;
-}
-
-static void raid6_decode(UINT64 off, UINT32 skip, read_data_context* context, CHUNK_ITEM* ci, UINT64* stripeoff, UINT8* buf,
-                         UINT32* pos, UINT32 length, UINT32 firststripesize) {
-    UINT16 parity1, stripe;
-    BOOL first = *pos == 0;
-    UINT32 stripelen = first ? firststripesize : ci->stripe_length;
-    
-    parity1 = ((off / ((ci->num_stripes - 2) * ci->stripe_length)) + ci->num_stripes - 2) % ci->num_stripes;
-    
-    stripe = (parity1 + 2) % ci->num_stripes;
-    
-    while (TRUE) {
-        if (stripe == parity1) {
-            *stripeoff += stripelen;
-            return;
-        }
-        
-        if (skip >= ci->stripe_length) {
-            skip -= ci->stripe_length;
-        } else {
-            UINT32 copylen = min(ci->stripe_length - skip, length - *pos);
-            
-            RtlCopyMemory(buf + *pos, &context->stripes[stripe].buf[*stripeoff + skip - ci->stripe_length + stripelen], copylen);
-            
-            *pos += copylen;
-            
-            if (*pos == length)
-                return;
-            
-            skip = 0;
-        }
-        
-        stripe = (stripe + 1) % ci->num_stripes;
-    }
-}
-
-static BOOL raid6_decode_with_checksum(UINT64 off, UINT32 skip, read_data_context* context, CHUNK_ITEM* ci, UINT64* stripeoff, UINT8* buf,
-                                       UINT32* pos, UINT32 length, UINT32 firststripesize, UINT32* csum, UINT32 sector_size) {
-    UINT16 parity1, parity2, stripe;
-    BOOL first = *pos == 0;
-    UINT32 stripelen = first ? firststripesize : ci->stripe_length;
-    
-    parity1 = ((off / ((ci->num_stripes - 2) * ci->stripe_length)) + ci->num_stripes - 2) % ci->num_stripes;
-    parity2 = (parity1 + 1) % ci->num_stripes;
-    stripe = (parity1 + 2) % ci->num_stripes;
-    
-    while (TRUE) {
-        if (stripe == parity1) {
-            *stripeoff += stripelen;
-            return TRUE;
-        }
-        
-        if (skip >= ci->stripe_length) {
-            skip -= ci->stripe_length;
-        } else {
-            UINT32 i;
-            UINT32 copylen = min(ci->stripe_length - skip, length - *pos);
-            
-            RtlCopyMemory(buf + *pos, &context->stripes[stripe].buf[*stripeoff + skip - ci->stripe_length + stripelen], copylen);
-            
-            for (i = 0; i < copylen / sector_size; i ++) {
-                UINT32 crc32 = ~calc_crc32c(0xffffffff, buf + *pos + (i * sector_size), sector_size);
-                
-                if (crc32 != csum[i]) {
-                    UINT16 j, firststripe;
-                    
-                    if (parity2 == 0 && stripe == 1)
-                        firststripe = 2;
-                    else if (parity2 == 0 || stripe == 0)
-                        firststripe = 1;
-                    else
-                        firststripe = 0;
-                    
-                    RtlCopyMemory(buf + *pos + (i * sector_size),
-                                  &context->stripes[firststripe].buf[*stripeoff + skip - ci->stripe_length + stripelen + (i * sector_size)], sector_size);
-                    
-                    for (j = firststripe + 1; j < ci->num_stripes; j++) {
-                        if (j != stripe && j != parity2) {
-                            do_xor(buf + *pos + (i * sector_size), &context->stripes[j].buf[*stripeoff + skip - ci->stripe_length + stripelen + (i * sector_size)], sector_size);
-                        }
-                    }
-                    
-                    crc32 = ~calc_crc32c(0xffffffff, buf + *pos + (i * sector_size), sector_size);
-                    
-                    if (crc32 != csum[i]) {
-                        UINT8 *parity, *buf2;
-                        UINT16 rs, div;
-                        
-                        // assume p is wrong
-                        
-                        parity = ExAllocatePoolWithTag(NonPagedPool, sector_size, ALLOC_TAG);
-                        if (!parity) {
-                            ERR("out of memory\n");
-                            return FALSE;
-                        }
-                        
-                        rs = (parity1 + ci->num_stripes - 1) % ci->num_stripes;
-                        j = ci->num_stripes - 3;
-                        
-                        if (rs == stripe) {
-                            RtlZeroMemory(parity, sector_size);
-                            div = j;
-                        } else
-                            RtlCopyMemory(parity, &context->stripes[rs].buf[*stripeoff + skip - ci->stripe_length + stripelen + (i * sector_size)], sector_size);
-                        
-                        rs = (rs + ci->num_stripes - 1) % ci->num_stripes;
-                        j--;
-                        while (rs != parity2) {
-                            galois_double(parity, sector_size);
-                            
-                            if (rs != stripe)
-                                do_xor(parity, &context->stripes[rs].buf[*stripeoff + skip - ci->stripe_length + stripelen + (i * sector_size)], sector_size);
-                            else
-                                div = j;
-            
-                            rs = (rs + ci->num_stripes - 1) % ci->num_stripes;
-                            j--;
-                        }
-                        
-                        do_xor(parity, &context->stripes[parity2].buf[*stripeoff + skip - ci->stripe_length + stripelen + (i * sector_size)], sector_size);
-                        
-                        if (div != 0)
-                            galois_divpower(parity, div, sector_size);
-                        
-                        crc32 = ~calc_crc32c(0xffffffff, parity, sector_size);
-                        if (crc32 == csum[i]) {
-                            RtlCopyMemory(buf + *pos + (i * sector_size), parity, sector_size);
-                            
-                            // recalculate p
-                            RtlCopyMemory(&context->stripes[parity1].buf[*stripeoff + skip - ci->stripe_length + stripelen + (i * sector_size)], parity, sector_size);
-                            
-                            for (j = 0; j < ci->num_stripes; j++) {
-                                if (j != stripe && j != parity1 && j != parity2) {
-                                    do_xor(&context->stripes[parity1].buf[*stripeoff + skip - ci->stripe_length + stripelen + (i * sector_size)],
-                                           &context->stripes[j].buf[*stripeoff + skip - ci->stripe_length + stripelen + (i * sector_size)], sector_size);
-                                }
-                            }
-                            
-                            context->stripes[parity1].rewrite = TRUE;
-                            
-                            ExFreePool(parity);
-                            goto success;
-                        }
-                        
-                        // assume another of the data stripes is wrong
-                        
-                        buf2 = ExAllocatePoolWithTag(NonPagedPool, sector_size, ALLOC_TAG);
-                        if (!buf2) {
-                            ERR("out of memory\n");
-                            ExFreePool(parity);
-                            return FALSE;
-                        }
-                        
-                        j = (parity2 + 1) % ci->num_stripes;
-                        
-                        while (j != parity1) {
-                            if (j != stripe) {
-                                UINT16 curstripe, k;
-                                UINT32 bufoff = *stripeoff + skip - ci->stripe_length + stripelen + (i * sector_size);
-                                UINT16 x, y;
-                                UINT8 gyx, gx, denom, a, b, *p, *q, *pxy, *qxy;
-                            
-                                curstripe = parity1 == 0 ? (ci->num_stripes - 1) : (parity1 - 1);
-                                
-                                // put qxy in parity
-                                // put pxy in buf2
-                                
-                                k = ci->num_stripes - 3;
-                                if (curstripe == stripe || curstripe == j) {
-                                    RtlZeroMemory(parity, sector_size);
-                                    RtlZeroMemory(buf2, sector_size);
-                                    
-                                    if (curstripe == stripe)
-                                        x = k;
-                                    else
-                                        y = k;
-                                } else {
-                                    RtlCopyMemory(parity, &context->stripes[curstripe].buf[bufoff], sector_size);
-                                    RtlCopyMemory(buf2, &context->stripes[curstripe].buf[bufoff], sector_size);
-                                }
-                                
-                                curstripe = curstripe == 0 ? (ci->num_stripes - 1) : (curstripe - 1);
-                                
-                                k--;
-                                do {
-                                    galois_double(parity, sector_size);
-                                    
-                                    if (curstripe != stripe && curstripe != j) {
-                                        do_xor(parity, &context->stripes[curstripe].buf[bufoff], sector_size);
-                                        do_xor(buf2, &context->stripes[curstripe].buf[bufoff], sector_size);
-                                    } else if (curstripe == stripe)
-                                        x = k;
-                                    else if (curstripe == j)
-                                        y = k;
-                                    
-                                    curstripe = curstripe == 0 ? (ci->num_stripes - 1) : (curstripe - 1);
-                                    k--;
-                                } while (curstripe != parity2);
-                                
-                                gyx = gpow2(y > x ? (y-x) : (255-x+y));
-                                gx = gpow2(255-x);
-
-                                denom = gdiv(1, gyx ^ 1);
-                                a = gmul(gyx, denom);
-                                b = gmul(gx, denom);
-                                
-                                p = &context->stripes[parity1].buf[bufoff];
-                                q = &context->stripes[parity2].buf[bufoff];
-                                pxy = buf2;
-                                qxy = parity; 
-                                
-                                for (k = 0; k < sector_size; k++) {
-                                    *qxy = gmul(a, *p ^ *pxy) ^ gmul(b, *q ^ *qxy);
-                                    
-                                    p++;
-                                    q++;
-                                    pxy++;
-                                    qxy++;
-                                }
-                                
-                                crc32 = ~calc_crc32c(0xffffffff, parity, sector_size);
-                                
-                                if (crc32 == csum[i]) {
-                                    do_xor(buf2, parity, sector_size);
-                                    do_xor(buf2, &context->stripes[parity1].buf[bufoff], sector_size);
-                                    
-                                    RtlCopyMemory(&context->stripes[j].buf[bufoff], buf2, sector_size);
-                                    context->stripes[j].rewrite = TRUE;
-                                    
-                                    RtlCopyMemory(buf + *pos + (i * sector_size), parity, sector_size);
-                                    ExFreePool(parity);
-                                    ExFreePool(buf2);
-                                    goto success;
-                                }
-                            }
-                            
-                            j = (j + 1) % ci->num_stripes;
-                        }
-                            
-                        ExFreePool(parity);
-                        ExFreePool(buf2);
-                        
-                        ERR("unrecoverable checksum error\n");
-                        return FALSE;
-                    }
-                    
-success:
-                    RtlCopyMemory(&context->stripes[stripe].buf[*stripeoff + skip - ci->stripe_length + stripelen + (i * sector_size)], buf + *pos + (i * sector_size), sector_size);
-                    context->stripes[stripe].rewrite = TRUE;
-                }
-            }
-            
-            *pos += copylen;
-            
-            if (*pos == length)
-                return TRUE;
-            
-            skip = 0;
-        }
-        
-        stripe = (stripe + 1) % ci->num_stripes;
-    }
-}
-
-static BOOL raid6_decode_with_checksum_metadata(UINT64 addr, UINT64 off, UINT32 skip, read_data_context* context, CHUNK_ITEM* ci, UINT64* stripeoff, UINT8* buf,
-                                                UINT32* pos, UINT32 length, UINT32 firststripesize, UINT32 node_size) {
-    UINT16 parity1, parity2, stripe;
-    BOOL first = *pos == 0;
-    UINT32 stripelen = first ? firststripesize : ci->stripe_length;
-    
-    parity1 = ((off / ((ci->num_stripes - 2) * ci->stripe_length)) + ci->num_stripes - 2) % ci->num_stripes;
-    parity2 = (parity1 + 1) % ci->num_stripes;
-    stripe = (parity1 + 2) % ci->num_stripes;
-    
-    while (TRUE) {
-        if (stripe == parity1) {
-            *stripeoff += stripelen;
-            return TRUE;
-        }
-        
-        if (skip >= ci->stripe_length) {
-            skip -= ci->stripe_length;
-        } else {
-            UINT32 copylen = min(ci->stripe_length - skip, length - *pos);
-            tree_header* th = (tree_header*)buf;
-            UINT32 crc32;
-            
-            RtlCopyMemory(buf + *pos, &context->stripes[stripe].buf[*stripeoff + skip - ci->stripe_length + stripelen], copylen);
-            
-            crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, node_size - sizeof(th->csum));
-            
-            if (addr != th->address || crc32 != *((UINT32*)th->csum)) {
-                UINT16 j, firststripe;
-                
-                if (parity2 == 0 && stripe == 1)
-                    firststripe = 2;
-                else if (parity2 == 0 || stripe == 0)
-                    firststripe = 1;
-                else
-                    firststripe = 0;
-                
-                RtlCopyMemory(buf + *pos, &context->stripes[firststripe].buf[*stripeoff + skip - ci->stripe_length + stripelen], node_size);
-                
-                for (j = firststripe + 1; j < ci->num_stripes; j++) {
-                    if (j != stripe && j != parity2) {
-                        do_xor(buf + *pos, &context->stripes[j].buf[*stripeoff + skip - ci->stripe_length + stripelen], node_size);
-                    }
-                }
-                
-                crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, node_size - sizeof(th->csum));
-                
-                if (addr != th->address || crc32 != *((UINT32*)th->csum)) {
-                    UINT8 *parity, *buf2;
-                    UINT16 rs, div;
-                    tree_header* th2;
-                    
-                    // assume p is wrong
-                    
-                    parity = ExAllocatePoolWithTag(NonPagedPool, node_size, ALLOC_TAG);
-                    if (!parity) {
-                        ERR("out of memory\n");
-                        return FALSE;
-                    }
-                    
-                    rs = (parity1 + ci->num_stripes - 1) % ci->num_stripes;
-                    j = ci->num_stripes - 3;
-                    
-                    if (rs == stripe) {
-                        RtlZeroMemory(parity, node_size);
-                        div = j;
-                    } else
-                        RtlCopyMemory(parity, &context->stripes[rs].buf[*stripeoff + skip - ci->stripe_length + stripelen], node_size);
-                    
-                    rs = (rs + ci->num_stripes - 1) % ci->num_stripes;
-                    j--;
-                    while (rs != parity2) {
-                        galois_double(parity, node_size);
-                        
-                        if (rs != stripe)
-                            do_xor(parity, &context->stripes[rs].buf[*stripeoff + skip - ci->stripe_length + stripelen], node_size);
-                        else
-                            div = j;
-        
-                        rs = (rs + ci->num_stripes - 1) % ci->num_stripes;
-                        j--;
-                    }
-                    
-                    do_xor(parity, &context->stripes[parity2].buf[*stripeoff + skip - ci->stripe_length + stripelen], node_size);
-                    
-                    if (div != 0)
-                        galois_divpower(parity, div, node_size);
-                    
-                    th2 = (tree_header*)parity;
-                    
-                    crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th2->fs_uuid, node_size - sizeof(th2->csum));
-                
-                    if (addr != th2->address || crc32 == *((UINT32*)th2->csum)) {
-                        RtlCopyMemory(buf + *pos, parity, node_size);
-                        
-                        // recalculate p
-                        RtlCopyMemory(&context->stripes[parity1].buf[*stripeoff + skip - ci->stripe_length + stripelen], parity, node_size);
-                        
-                        for (j = 0; j < ci->num_stripes; j++) {
-                            if (j != stripe && j != parity1 && j != parity2) {
-                                do_xor(&context->stripes[parity1].buf[*stripeoff + skip - ci->stripe_length + stripelen],
-                                        &context->stripes[j].buf[*stripeoff + skip - ci->stripe_length + stripelen], node_size);
-                            }
-                        }
-                        
-                        context->stripes[parity1].rewrite = TRUE;
-                        
-                        ExFreePool(parity);
-                        goto success;
-                    }
-                    
-                    // assume another of the data stripes is wrong
-                    
-                    buf2 = ExAllocatePoolWithTag(NonPagedPool, node_size, ALLOC_TAG);
-                    if (!buf2) {
-                        ERR("out of memory\n");
-                        ExFreePool(parity);
-                        return FALSE;
-                    }
-                    
-                    j = (parity2 + 1) % ci->num_stripes;
-                    
-                    while (j != parity1) {
-                        if (j != stripe) {
-                            UINT16 curstripe, k;
-                            UINT32 bufoff = *stripeoff + skip - ci->stripe_length + stripelen;
-                            UINT16 x, y;
-                            UINT8 gyx, gx, denom, a, b, *p, *q, *pxy, *qxy;
-                        
-                            curstripe = parity1 == 0 ? (ci->num_stripes - 1) : (parity1 - 1);
-                            
-                            // put qxy in parity
-                            // put pxy in buf2
-                            
-                            k = ci->num_stripes - 3;
-                            if (curstripe == stripe || curstripe == j) {
-                                RtlZeroMemory(parity, node_size);
-                                RtlZeroMemory(buf2, node_size);
-                                
-                                if (curstripe == stripe)
-                                    x = k;
-                                else
-                                    y = k;
-                            } else {
-                                RtlCopyMemory(parity, &context->stripes[curstripe].buf[bufoff], node_size);
-                                RtlCopyMemory(buf2, &context->stripes[curstripe].buf[bufoff], node_size);
-                            }
-                            
-                            curstripe = curstripe == 0 ? (ci->num_stripes - 1) : (curstripe - 1);
-                            
-                            k--;
-                            do {
-                                galois_double(parity, node_size);
-                                
-                                if (curstripe != stripe && curstripe != j) {
-                                    do_xor(parity, &context->stripes[curstripe].buf[bufoff], node_size);
-                                    do_xor(buf2, &context->stripes[curstripe].buf[bufoff], node_size);
-                                } else if (curstripe == stripe)
-                                    x = k;
-                                else if (curstripe == j)
-                                    y = k;
-                                
-                                curstripe = curstripe == 0 ? (ci->num_stripes - 1) : (curstripe - 1);
-                                k--;
-                            } while (curstripe != parity2);
-                            
-                            gyx = gpow2(y > x ? (y-x) : (255-x+y));
-                            gx = gpow2(255-x);
-
-                            denom = gdiv(1, gyx ^ 1);
-                            a = gmul(gyx, denom);
-                            b = gmul(gx, denom);
-                            
-                            p = &context->stripes[parity1].buf[bufoff];
-                            q = &context->stripes[parity2].buf[bufoff];
-                            pxy = buf2;
-                            qxy = parity; 
-                            
-                            for (k = 0; k < node_size; k++) {
-                                *qxy = gmul(a, *p ^ *pxy) ^ gmul(b, *q ^ *qxy);
-                                
-                                p++;
-                                q++;
-                                pxy++;
-                                qxy++;
-                            }
-                            
-                            th2 = (tree_header*)parity;
-                    
-                            crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th2->fs_uuid, node_size - sizeof(th2->csum));
-                        
-                            if (addr != th2->address || crc32 == *((UINT32*)th2->csum)) {
-                                do_xor(buf2, parity, node_size);
-                                do_xor(buf2, &context->stripes[parity1].buf[bufoff], node_size);
-                                
-                                RtlCopyMemory(&context->stripes[j].buf[bufoff], buf2, node_size);
-                                context->stripes[j].rewrite = TRUE;
-                                
-                                RtlCopyMemory(buf + *pos, parity, node_size);
-                                ExFreePool(parity);
-                                ExFreePool(buf2);
-                                goto success;
-                            }
-                        }
-                        
-                        j = (j + 1) % ci->num_stripes;
-                    }
-                        
-                    ExFreePool(parity);
-                    ExFreePool(buf2);
-                    
-                    ERR("unrecoverable checksum error\n");
-                    return FALSE;
-                }
-                
-success:
-                RtlCopyMemory(&context->stripes[stripe].buf[*stripeoff + skip - ci->stripe_length + stripelen], buf + *pos, node_size);
-                context->stripes[stripe].rewrite = TRUE;
-            }
-            
-            *pos += copylen;
-            
-            if (*pos == length)
-                return TRUE;
-            
-            skip = 0;
-        }
-        
-        stripe = (stripe + 1) % ci->num_stripes;
-    }
-}
-
-static NTSTATUS check_raid6_nocsum_parity(UINT64 off, UINT32 skip, read_data_context* context, CHUNK_ITEM* ci, UINT64* stripeoff, UINT64 maxsize,
-                                          BOOL first, UINT32 firststripesize, UINT8* scratch) {
-    UINT16 parity1, parity2, stripe;
-    UINT32 stripelen = first ? firststripesize : ci->stripe_length;
-    UINT32 readlen, i;
-    BOOL bad = FALSE;
-    
-    TRACE("(%llx, %x, %p, %p, %llx, %llx, %u, %x, %p)\n", off, skip, context, ci, *stripeoff, maxsize, first, firststripesize, scratch);
-    
-    parity1 = ((off / ((ci->num_stripes - 2) * ci->stripe_length)) + ci->num_stripes - 2) % ci->num_stripes;
-    parity2 = (parity1 + 1) % ci->num_stripes;
-    
-    readlen = min(min(ci->stripe_length - (skip % ci->stripe_length), stripelen), maxsize - *stripeoff);
-    
-    RtlCopyMemory(scratch, &context->stripes[parity1].buf[*stripeoff], readlen);
-    stripe = parity1 == 0 ? (ci->num_stripes - 1) : (parity1 - 1);
-    
-    do {
-        do_xor(scratch, &context->stripes[stripe].buf[*stripeoff], readlen);
-        
-        stripe = stripe == 0 ? (ci->num_stripes - 1) : (stripe - 1);
-    } while (stripe != parity2);
-    
-    for (i = 0; i < readlen; i++) {
-        if (scratch[i] != 0) {
-            bad = TRUE;
-            break;
-        }
-    }
-    
-    if (bad) {
-        UINT16 missing;
-        UINT8* buf2;
-        
-        // assume parity is bad
-        stripe = parity1 == 0 ? (ci->num_stripes - 1) : (parity1 - 1);
-        RtlCopyMemory(scratch, &context->stripes[stripe].buf[*stripeoff], readlen);
-        stripe = stripe == 0 ? (ci->num_stripes - 1) : (stripe - 1);
-        
-        do {
-            galois_double(scratch, readlen);
-            
-            do_xor(scratch, &context->stripes[stripe].buf[*stripeoff], readlen);
-            
-            stripe = stripe == 0 ? (ci->num_stripes - 1) : (stripe - 1);
-        } while (stripe != parity2);
-        
-        if (RtlCompareMemory(scratch, &context->stripes[parity2].buf[*stripeoff], readlen) == readlen) {
-            WARN("recovering from invalid parity stripe\n");
-            
-            // recalc p
-            stripe = parity1 == 0 ? (ci->num_stripes - 1) : (parity1 - 1);
-            RtlCopyMemory(&context->stripes[parity1].buf[*stripeoff], &context->stripes[stripe].buf[*stripeoff], readlen);
-            stripe = stripe == 0 ? (ci->num_stripes - 1) : (stripe - 1);
-        
-            do {
-                do_xor(&context->stripes[parity1].buf[*stripeoff], &context->stripes[stripe].buf[*stripeoff], readlen);
-                
-                stripe = stripe == 0 ? (ci->num_stripes - 1) : (stripe - 1);
-            } while (stripe != parity2);
-            
-            context->stripes[parity1].rewrite = TRUE;
-            goto end;
-        }
-        
-        // assume one of the data stripes is bad
-        
-        buf2 = ExAllocatePoolWithTag(NonPagedPool, readlen, ALLOC_TAG);
-        if (!buf2) {
-            ERR("out of memory\n");
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
-        
-        missing = (parity2 + 1) % ci->num_stripes;
-        while (missing != parity1) {
-            RtlCopyMemory(scratch, &context->stripes[parity1].buf[*stripeoff], readlen);
-            for (i = 0; i < ci->num_stripes; i++) {
-                if (i != parity1 && i != parity2 && i != missing) {
-                    do_xor(scratch, &context->stripes[i].buf[*stripeoff], readlen);
-                }
-            }
-            
-            stripe = parity1 == 0 ? (ci->num_stripes - 1) : (parity1 - 1);
-            RtlCopyMemory(buf2, stripe == missing ? scratch : &context->stripes[stripe].buf[*stripeoff], readlen);
-            stripe = stripe == 0 ? (ci->num_stripes - 1) : (stripe - 1);
-            
-            do {
-                galois_double(buf2, readlen);
-                
-                do_xor(buf2, stripe == missing ? scratch : &context->stripes[stripe].buf[*stripeoff], readlen);
-                
-                stripe = stripe == 0 ? (ci->num_stripes - 1) : (stripe - 1);
-            } while (stripe != parity2);
-            
-            if (RtlCompareMemory(buf2, &context->stripes[parity2].buf[*stripeoff], readlen) == readlen) {
-                WARN("recovering from invalid data stripe\n");
-                
-                RtlCopyMemory(&context->stripes[missing].buf[*stripeoff], scratch, readlen);
-                ExFreePool(buf2);
-                
-                context->stripes[missing].rewrite = TRUE;
-                goto end;
-            }
-            
-            missing = (missing + 1) % ci->num_stripes;
-        }
-        
-        ExFreePool(buf2);
-        
-        ERR("unrecoverable checksum error\n");
-        return STATUS_CRC_ERROR;
-    }
-    
-end:
-    *stripeoff += stripelen;
-    
-    return STATUS_SUCCESS;
-}
-
-static NTSTATUS check_csum(device_extension* Vcb, UINT8* data, UINT32 sectors, UINT32* csum) {
+NTSTATUS check_csum(device_extension* Vcb, UINT8* data, UINT32 sectors, UINT32* csum) {
     NTSTATUS Status;
     calc_job* cj;
     UINT32* csum2;
-    
+
     // From experimenting, it seems that 40 sectors is roughly the crossover
     // point where offloading the crc32 calculation becomes worth it.
-    
-    if (sectors < 40) {
+
+    if (sectors < 40 || KeQueryActiveProcessorCount(NULL) < 2) {
         ULONG j;
-        
+
         for (j = 0; j < sectors; j++) {
             UINT32 crc32 = ~calc_crc32c(0xffffffff, data + (j * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
-            
+
             if (crc32 != csum[j]) {
                 return STATUS_CRC_ERROR;
             }
         }
-        
+
         return STATUS_SUCCESS;
     }
-    
+
     csum2 = ExAllocatePoolWithTag(PagedPool, sizeof(UINT32) * sectors, ALLOC_TAG);
     if (!csum2) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     Status = add_calc_job(Vcb, data, sectors, csum2, &cj);
     if (!NT_SUCCESS(Status)) {
         ERR("add_calc_job returned %08x\n", Status);
+        ExFreePool(csum2);
         return Status;
     }
-    
+
     KeWaitForSingleObject(&cj->event, Executive, KernelMode, FALSE, NULL);
-    
+
     if (RtlCompareMemory(csum2, csum, sectors * sizeof(UINT32)) != sectors * sizeof(UINT32)) {
         free_calc_job(cj);
         ExFreePool(csum2);
         return STATUS_CRC_ERROR;
     }
-    
+
     free_calc_job(cj);
     ExFreePool(csum2);
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS read_data_dup(device_extension* Vcb, UINT8* buf, UINT64 addr, UINT32 length, PIRP Irp, read_data_context* context,
-                              CHUNK_ITEM* ci, device** devices, UINT64 *stripestart, UINT64 *stripeend) {
-    UINT64 i;
+static NTSTATUS read_data_dup(device_extension* Vcb, UINT8* buf, UINT64 addr, read_data_context* context, CHUNK_ITEM* ci,
+                              device** devices, UINT64 generation) {
+    ULONG i;
     BOOL checksum_error = FALSE;
-    UINT16 cancelled = 0;
+    UINT16 j, stripe = 0;
     NTSTATUS Status;
-    
-    for (i = 0; i < ci->num_stripes; i++) {
-        if (context->stripes[i].status == ReadDataStatus_Success) {
-            if (context->tree) {
-                tree_header* th = (tree_header*)context->stripes[i].buf;
-                UINT32 crc32;
-                
-                crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, context->buflen - sizeof(th->csum));
-                
-                if (th->address != context->address || crc32 != *((UINT32*)th->csum)) {
-                    context->stripes[i].status = ReadDataStatus_CRCError;
-                    checksum_error = TRUE;
-                }
-            } else if (context->csum) {
-#ifdef DEBUG_STATS
-                LARGE_INTEGER time1, time2;
-                
-                time1 = KeQueryPerformanceCounter(NULL);
-#endif
-                Status = check_csum(Vcb, context->stripes[i].buf, context->stripes[i].Irp->IoStatus.Information / context->sector_size, context->csum);
-                
-                if (Status == STATUS_CRC_ERROR) {
-                    context->stripes[i].status = ReadDataStatus_CRCError;
-                    checksum_error = TRUE;
-                    break;
-                } else if (!NT_SUCCESS(Status)) {
-                    ERR("check_csum returned %08x\n", Status);
-                    return Status;
-                }
-#ifdef DEBUG_STATS
-                time2 = KeQueryPerformanceCounter(NULL);
-                
-                Vcb->stats.read_csum_time += time2.QuadPart - time1.QuadPart;
-#endif
-            }
-        } else if (context->stripes[i].status == ReadDataStatus_Cancelled) {
-            cancelled++;
+    CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&ci[1];
+
+    for (j = 0; j < ci->num_stripes; j++) {
+        if (context->stripes[j].status == ReadDataStatus_Error) {
+            WARN("stripe %u returned error %08x\n", j, context->stripes[j].iosb.Status);
+            log_device_error(Vcb, devices[j], BTRFS_DEV_STAT_READ_ERRORS);
+            return context->stripes[j].iosb.Status;
+        } else if (context->stripes[j].status == ReadDataStatus_Success) {
+            stripe = j;
+            break;
         }
     }
-    
-    if (checksum_error) {
-        CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&ci[1];
-        
-        // FIXME - update dev stats
-        
-        if (cancelled > 0) {
+
+    if (context->stripes[stripe].status != ReadDataStatus_Success)
+        return STATUS_INTERNAL_ERROR;
+
+    if (context->tree) {
+        tree_header* th = (tree_header*)buf;
+        UINT32 crc32;
+
+        crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, context->buflen - sizeof(th->csum));
+
+        if (th->address != context->address || crc32 != *((UINT32*)th->csum)) {
+            checksum_error = TRUE;
+            log_device_error(Vcb, devices[stripe], BTRFS_DEV_STAT_CORRUPTION_ERRORS);
+        } else if (generation != 0 && th->generation != generation) {
+            checksum_error = TRUE;
+            log_device_error(Vcb, devices[stripe], BTRFS_DEV_STAT_GENERATION_ERRORS);
+        }
+    } else if (context->csum) {
 #ifdef DEBUG_STATS
-            LARGE_INTEGER time1, time2;
+        LARGE_INTEGER time1, time2;
+
+        time1 = KeQueryPerformanceCounter(NULL);
 #endif
-            context->stripes_left = 0;
-            
-            for (i = 0; i < ci->num_stripes; i++) {
-                if (context->stripes[i].status == ReadDataStatus_Cancelled) {
-                    PIO_STACK_LOCATION IrpSp;
-                    
-                    // re-run Irp that we cancelled
-                    
-                    if (context->stripes[i].Irp) {
-                        if (devices[i]->devobj->Flags & DO_DIRECT_IO) {
-                            MmUnlockPages(context->stripes[i].Irp->MdlAddress);
-                            IoFreeMdl(context->stripes[i].Irp->MdlAddress);
-                        }
-                        IoFreeIrp(context->stripes[i].Irp);
-                    }
-                    
-                    if (!Irp) {
-                        context->stripes[i].Irp = IoAllocateIrp(devices[i]->devobj->StackSize, FALSE);
-                        
-                        if (!context->stripes[i].Irp) {
-                            ERR("IoAllocateIrp failed\n");
-                            return STATUS_INSUFFICIENT_RESOURCES;
-                        }
-                    } else {
-                        context->stripes[i].Irp = IoMakeAssociatedIrp(Irp, devices[i]->devobj->StackSize);
-                        
-                        if (!context->stripes[i].Irp) {
-                            ERR("IoMakeAssociatedIrp failed\n");
-                            return STATUS_INSUFFICIENT_RESOURCES;
-                        }
-                    }
-                    
-                    IrpSp = IoGetNextIrpStackLocation(context->stripes[i].Irp);
-                    IrpSp->MajorFunction = IRP_MJ_READ;
-                    
-                    if (devices[i]->devobj->Flags & DO_BUFFERED_IO) {
-                        FIXME("FIXME - buffered IO\n");
-                    } else if (devices[i]->devobj->Flags & DO_DIRECT_IO) {
-                        context->stripes[i].Irp->MdlAddress = IoAllocateMdl(context->stripes[i].buf, stripeend[i] - stripestart[i], FALSE, FALSE, NULL);
-                        if (!context->stripes[i].Irp->MdlAddress) {
-                            ERR("IoAllocateMdl failed\n");
-                            return STATUS_INSUFFICIENT_RESOURCES;
-                        }
-                        
-                        MmProbeAndLockPages(context->stripes[i].Irp->MdlAddress, KernelMode, IoWriteAccess);
-                    } else {
-                        context->stripes[i].Irp->UserBuffer = context->stripes[i].buf;
-                    }
+        Status = check_csum(Vcb, buf, (ULONG)context->stripes[stripe].Irp->IoStatus.Information / context->sector_size, context->csum);
 
-                    IrpSp->Parameters.Read.Length = stripeend[i] - stripestart[i];
-                    IrpSp->Parameters.Read.ByteOffset.QuadPart = stripestart[i] + cis[i].offset;
-                    
-                    context->stripes[i].Irp->UserIosb = &context->stripes[i].iosb;
-                    
-                    IoSetCompletionRoutine(context->stripes[i].Irp, read_data_completion, &context->stripes[i], TRUE, TRUE, TRUE);
-                    
-                    context->stripes_left++;
-                    context->stripes[i].status = ReadDataStatus_Pending;
-                }
-            }
-            
-            context->stripes_cancel = 0;
-            KeClearEvent(&context->Event);
-            
+        if (Status == STATUS_CRC_ERROR) {
+            checksum_error = TRUE;
+            log_device_error(Vcb, devices[stripe], BTRFS_DEV_STAT_CORRUPTION_ERRORS);
+        } else if (!NT_SUCCESS(Status)) {
+            ERR("check_csum returned %08x\n", Status);
+            return Status;
+        }
 #ifdef DEBUG_STATS
-            if (!context->tree)
-                time1 = KeQueryPerformanceCounter(NULL);
+        time2 = KeQueryPerformanceCounter(NULL);
+
+        Vcb->stats.read_csum_time += time2.QuadPart - time1.QuadPart;
 #endif
+    }
 
-            for (i = 0; i < ci->num_stripes; i++) {
-                if (context->stripes[i].status == ReadDataStatus_Pending) {
-                    IoCallDriver(devices[i]->devobj, context->stripes[i].Irp);
-                }
-            }
-            
-            KeWaitForSingleObject(&context->Event, Executive, KernelMode, FALSE, NULL);
-            
-#ifdef DEBUG_STATS
-            if (!context->tree) {
-                time2 = KeQueryPerformanceCounter(NULL);
-                
-                Vcb->stats.read_disk_time += time2.QuadPart - time1.QuadPart;
-            }
-#endif
-            for (i = 0; i < ci->num_stripes; i++) {
-                if (context->stripes[i].status == ReadDataStatus_Success) {
-                    if (context->tree) {
-                        tree_header* th = (tree_header*)context->stripes[i].buf;
-                        UINT32 crc32;
-                        
-                        crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, context->buflen - sizeof(th->csum));
-                        
-                        if (th->address != context->address || crc32 != *((UINT32*)th->csum))
-                            context->stripes[i].status = ReadDataStatus_CRCError;
-                    } else if (context->csum) {
-                        NTSTATUS Status;
-#ifdef DEBUG_STATS
-                        time1 = KeQueryPerformanceCounter(NULL);
-#endif
-                        Status = check_csum(Vcb, context->stripes[i].buf, context->stripes[i].Irp->IoStatus.Information / Vcb->superblock.sector_size, context->csum);
-                        
-                        if (Status == STATUS_CRC_ERROR)
-                            context->stripes[i].status = ReadDataStatus_CRCError;
-                        else if (!NT_SUCCESS(Status)) {
-                            ERR("check_csum returned %08x\n", Status);
-                            return Status;
+    if (!checksum_error)
+        return STATUS_SUCCESS;
+
+    if (ci->num_stripes == 1)
+        return STATUS_CRC_ERROR;
+
+    if (context->tree) {
+        tree_header* t2;
+        BOOL recovered = FALSE;
+
+        t2 = ExAllocatePoolWithTag(NonPagedPool, Vcb->superblock.node_size, ALLOC_TAG);
+        if (!t2) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+
+        for (j = 0; j < ci->num_stripes; j++) {
+            if (j != stripe && devices[j] && devices[j]->devobj) {
+                Status = sync_read_phys(devices[j]->devobj, cis[j].offset + context->stripes[stripe].stripestart, Vcb->superblock.node_size, (UINT8*)t2, FALSE);
+                if (!NT_SUCCESS(Status)) {
+                    WARN("sync_read_phys returned %08x\n", Status);
+                    log_device_error(Vcb, devices[j], BTRFS_DEV_STAT_READ_ERRORS);
+                } else {
+                    UINT32 crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&t2->fs_uuid, Vcb->superblock.node_size - sizeof(t2->csum));
+
+                    if (t2->address == addr && crc32 == *((UINT32*)t2->csum) && (generation == 0 || t2->generation == generation)) {
+                        RtlCopyMemory(buf, t2, Vcb->superblock.node_size);
+                        ERR("recovering from checksum error at %llx, device %llx\n", addr, devices[stripe]->devitem.dev_id);
+                        recovered = TRUE;
+
+                        if (!Vcb->readonly && !devices[stripe]->readonly) { // write good data over bad
+                            Status = write_data_phys(devices[stripe]->devobj, cis[stripe].offset + context->stripes[stripe].stripestart,
+                                                     t2, Vcb->superblock.node_size);
+                            if (!NT_SUCCESS(Status)) {
+                                WARN("write_data_phys returned %08x\n", Status);
+                                log_device_error(Vcb, devices[stripe], BTRFS_DEV_STAT_WRITE_ERRORS);
+                            }
                         }
-#ifdef DEBUG_STATS
-                        time2 = KeQueryPerformanceCounter(NULL);
-                        
-                        Vcb->stats.read_csum_time += time2.QuadPart - time1.QuadPart;
-#endif
-                    }
+
+                        break;
+                    } else if (t2->address != addr || crc32 != *((UINT32*)t2->csum))
+                        log_device_error(Vcb, devices[j], BTRFS_DEV_STAT_CORRUPTION_ERRORS);
+                    else
+                        log_device_error(Vcb, devices[j], BTRFS_DEV_STAT_GENERATION_ERRORS);
                 }
             }
         }
-        
-        for (i = 0; i < ci->num_stripes; i++) {
-            if (context->stripes[i].status == ReadDataStatus_Success) {
-                RtlCopyMemory(buf, context->stripes[i].buf, length);
-                goto raid1write;
-            }
-        }
-        
-        if (context->tree || ci->num_stripes == 1) { // unable to recover from checksum error
+
+        if (!recovered) {
             ERR("unrecoverable checksum error at %llx\n", addr);
-            
-#ifdef _DEBUG
-            if (context->tree) {
-                for (i = 0; i < ci->num_stripes; i++) {
-                    if (context->stripes[i].status == ReadDataStatus_CRCError) {
-                        tree_header* th = (tree_header*)context->stripes[i].buf;
-                        UINT32 crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, context->buflen - sizeof(th->csum));
-                        
-                        if (crc32 != *((UINT32*)th->csum)) {
-                            WARN("crc32 was %08x, expected %08x\n", crc32, *((UINT32*)th->csum));
-                            return STATUS_CRC_ERROR;
-                        } else if (addr != th->address) {
-                            WARN("address of tree was %llx, not %llx as expected\n", th->address, addr);
-                            return STATUS_CRC_ERROR;
-                        }
-                    }
-                }
-            }
-#endif
+            ExFreePool(t2);
             return STATUS_CRC_ERROR;
         }
-        
-        // checksum errors on both stripes - we need to check sector by sector
-        
-        for (i = 0; i < (stripeend[0] - stripestart[0]) / context->sector_size; i++) {
-            UINT16 j;
-            BOOL success = FALSE;
-#ifdef DEBUG_STATS
-            LARGE_INTEGER time1, time2;
-            
-            time1 = KeQueryPerformanceCounter(NULL);
-#endif
-            
-            for (j = 0; j < ci->num_stripes; j++) {
-                if (context->stripes[j].status == ReadDataStatus_CRCError) {
-                    UINT32 crc32 = ~calc_crc32c(0xffffffff, context->stripes[j].buf + (i * context->sector_size), context->sector_size);
-                    
-                    if (crc32 == context->csum[i]) {
-                        RtlCopyMemory(buf + (i * context->sector_size), context->stripes[j].buf + (i * context->sector_size), context->sector_size);
-                        success = TRUE;
-                        break;
+
+        ExFreePool(t2);
+    } else {
+        ULONG sectors = (ULONG)context->stripes[stripe].Irp->IoStatus.Information / Vcb->superblock.sector_size;
+        UINT8* sector;
+
+        sector = ExAllocatePoolWithTag(NonPagedPool, Vcb->superblock.sector_size, ALLOC_TAG);
+        if (!sector) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+
+        for (i = 0; i < sectors; i++) {
+            UINT32 crc32 = ~calc_crc32c(0xffffffff, buf + (i * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
+
+            if (context->csum[i] != crc32) {
+                BOOL recovered = FALSE;
+
+                for (j = 0; j < ci->num_stripes; j++) {
+                    if (j != stripe && devices[j] && devices[j]->devobj) {
+                        Status = sync_read_phys(devices[j]->devobj, cis[j].offset + context->stripes[stripe].stripestart + UInt32x32To64(i, Vcb->superblock.sector_size),
+                                                Vcb->superblock.sector_size, sector, FALSE);
+                        if (!NT_SUCCESS(Status)) {
+                            WARN("sync_read_phys returned %08x\n", Status);
+                            log_device_error(Vcb, devices[j], BTRFS_DEV_STAT_READ_ERRORS);
+                        } else {
+                            UINT32 crc32b = ~calc_crc32c(0xffffffff, sector, Vcb->superblock.sector_size);
+
+                            if (crc32b == context->csum[i]) {
+                                RtlCopyMemory(buf + (i * Vcb->superblock.sector_size), sector, Vcb->superblock.sector_size);
+                                ERR("recovering from checksum error at %llx, device %llx\n", addr + UInt32x32To64(i, Vcb->superblock.sector_size), devices[stripe]->devitem.dev_id);
+                                recovered = TRUE;
+
+                                if (!Vcb->readonly && !devices[stripe]->readonly) { // write good data over bad
+                                    Status = write_data_phys(devices[stripe]->devobj, cis[stripe].offset + context->stripes[stripe].stripestart + UInt32x32To64(i, Vcb->superblock.sector_size),
+                                                             sector, Vcb->superblock.sector_size);
+                                    if (!NT_SUCCESS(Status)) {
+                                        WARN("write_data_phys returned %08x\n", Status);
+                                        log_device_error(Vcb, devices[stripe], BTRFS_DEV_STAT_WRITE_ERRORS);
+                                    }
+                                }
+
+                                break;
+                            } else
+                                log_device_error(Vcb, devices[j], BTRFS_DEV_STAT_CORRUPTION_ERRORS);
+                        }
                     }
                 }
-            }
-            
-#ifdef DEBUG_STATS
-            time2 = KeQueryPerformanceCounter(NULL);
 
-            Vcb->stats.read_csum_time += time2.QuadPart - time1.QuadPart;
-#endif
-            if (!success) {
-                ERR("unrecoverable checksum error at %llx\n", addr + (i * context->sector_size));
-                return STATUS_CRC_ERROR;
-            }
-        }
-        
-raid1write:
-        // write good data over bad
-        
-        if (!Vcb->readonly) {
-            for (i = 0; i < ci->num_stripes; i++) {
-                if (context->stripes[i].status == ReadDataStatus_CRCError && devices[i] && !devices[i]->readonly) {
-                    Status = write_data_phys(devices[i]->devobj, cis[i].offset + stripestart[i], buf, length);
-                    
-                    if (!NT_SUCCESS(Status))
-                        WARN("write_data_phys returned %08x\n", Status);
+                if (!recovered) {
+                    ERR("unrecoverable checksum error at %llx\n", addr + UInt32x32To64(i, Vcb->superblock.sector_size));
+                    ExFreePool(sector);
+                    return STATUS_CRC_ERROR;
                 }
             }
         }
-        
-        return STATUS_SUCCESS;
+
+        ExFreePool(sector);
     }
-    
-    // check if any of the stripes succeeded
-    
-    for (i = 0; i < ci->num_stripes; i++) {
-        if (context->stripes[i].status == ReadDataStatus_Success) {
-            RtlCopyMemory(buf, context->stripes[i].buf, length);
-            return STATUS_SUCCESS;
-        }
-    }
-    
-    // failing that, return the first error we encountered
-    
-    for (i = 0; i < ci->num_stripes; i++) {
-        if (context->stripes[i].status == ReadDataStatus_Error)
-            return context->stripes[i].iosb.Status;
-    }
-    
-    // if we somehow get here, return STATUS_INTERNAL_ERROR
-    
-    return STATUS_INTERNAL_ERROR;
+
+    return STATUS_SUCCESS;
 }
 
 static NTSTATUS read_data_raid0(device_extension* Vcb, UINT8* buf, UINT64 addr, UINT32 length, read_data_context* context,
-                                CHUNK_ITEM* ci, UINT64* stripestart, UINT64* stripeend, UINT16 startoffstripe) {
+                                CHUNK_ITEM* ci, device** devices, UINT64 generation, UINT64 offset) {
     UINT64 i;
-    UINT32 pos, *stripeoff;
-    UINT8 stripe;
-    
+
     for (i = 0; i < ci->num_stripes; i++) {
         if (context->stripes[i].status == ReadDataStatus_Error) {
-            WARN("stripe %llu returned error %08x\n", i, context->stripes[i].iosb.Status); 
+            WARN("stripe %llu returned error %08x\n", i, context->stripes[i].iosb.Status);
+            log_device_error(Vcb, devices[i], BTRFS_DEV_STAT_READ_ERRORS);
             return context->stripes[i].iosb.Status;
         }
     }
-    
-    pos = 0;
-    stripeoff = ExAllocatePoolWithTag(NonPagedPool, sizeof(UINT32) * ci->num_stripes, ALLOC_TAG);
-    if (!stripeoff) {
-        ERR("out of memory\n");
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
-    RtlZeroMemory(stripeoff, sizeof(UINT32) * ci->num_stripes);
-    
-    stripe = startoffstripe;
-    while (pos < length) {
-        if (pos == 0) {
-            UINT32 readlen = min(stripeend[stripe] - stripestart[stripe], ci->stripe_length - (stripestart[stripe] % ci->stripe_length));
-            
-            RtlCopyMemory(buf, context->stripes[stripe].buf, readlen);
-            stripeoff[stripe] += readlen;
-            pos += readlen;
-        } else if (length - pos < ci->stripe_length) {
-            RtlCopyMemory(buf + pos, &context->stripes[stripe].buf[stripeoff[stripe]], length - pos);
-            pos = length;
-        } else {
-            RtlCopyMemory(buf + pos, &context->stripes[stripe].buf[stripeoff[stripe]], ci->stripe_length);
-            stripeoff[stripe] += ci->stripe_length;
-            pos += ci->stripe_length;
-        }
-        
-        stripe = (stripe + 1) % ci->num_stripes;
-    }
-    
-    ExFreePool(stripeoff);
-    
-    // FIXME - handle the case where one of the stripes doesn't read everything, i.e. Irp->IoStatus.Information is short
-    
+
     if (context->tree) { // shouldn't happen, as trees shouldn't cross stripe boundaries
         tree_header* th = (tree_header*)buf;
         UINT32 crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&th->fs_uuid, Vcb->superblock.node_size - sizeof(th->csum));
-        
-        if (crc32 != *((UINT32*)th->csum)) {
-            WARN("crc32 was %08x, expected %08x\n", crc32, *((UINT32*)th->csum));
-            return STATUS_CRC_ERROR;
-        } else if (addr != th->address) {
-            WARN("address of tree was %llx, not %llx as expected\n", th->address, addr);
-            return STATUS_CRC_ERROR;
+
+        if (crc32 != *((UINT32*)th->csum) || addr != th->address || (generation != 0 && generation != th->generation)) {
+            UINT64 off;
+            UINT16 stripe;
+
+            get_raid0_offset(addr - offset, ci->stripe_length, ci->num_stripes, &off, &stripe);
+
+            ERR("unrecoverable checksum error at %llx, device %llx\n", addr, devices[stripe]->devitem.dev_id);
+
+            if (crc32 != *((UINT32*)th->csum)) {
+                WARN("crc32 was %08x, expected %08x\n", crc32, *((UINT32*)th->csum));
+                log_device_error(Vcb, devices[stripe], BTRFS_DEV_STAT_CORRUPTION_ERRORS);
+                return STATUS_CRC_ERROR;
+            } else if (addr != th->address) {
+                WARN("address of tree was %llx, not %llx as expected\n", th->address, addr);
+                log_device_error(Vcb, devices[stripe], BTRFS_DEV_STAT_CORRUPTION_ERRORS);
+                return STATUS_CRC_ERROR;
+            } else if (generation != 0 && generation != th->generation) {
+                WARN("generation of tree was %llx, not %llx as expected\n", th->generation, generation);
+                log_device_error(Vcb, devices[stripe], BTRFS_DEV_STAT_GENERATION_ERRORS);
+                return STATUS_CRC_ERROR;
+            }
         }
     } else if (context->csum) {
         NTSTATUS Status;
 #ifdef DEBUG_STATS
         LARGE_INTEGER time1, time2;
-        
+
         time1 = KeQueryPerformanceCounter(NULL);
 #endif
         Status = check_csum(Vcb, buf, length / Vcb->superblock.sector_size, context->csum);
-        
+
         if (Status == STATUS_CRC_ERROR) {
-            WARN("checksum error\n");
+            for (i = 0; i < length / Vcb->superblock.sector_size; i++) {
+                UINT32 crc32 = ~calc_crc32c(0xffffffff, buf + (i * Vcb->superblock.sector_size), Vcb->superblock.sector_size);
+
+                if (context->csum[i] != crc32) {
+                    UINT64 off;
+                    UINT16 stripe;
+
+                    get_raid0_offset(addr - offset + UInt32x32To64(i, Vcb->superblock.sector_size), ci->stripe_length, ci->num_stripes, &off, &stripe);
+
+                    ERR("unrecoverable checksum error at %llx, device %llx\n", addr, devices[stripe]->devitem.dev_id);
+
+                    log_device_error(Vcb, devices[stripe], BTRFS_DEV_STAT_CORRUPTION_ERRORS);
+
+                    return Status;
+                }
+            }
+
             return Status;
         } else if (!NT_SUCCESS(Status)) {
             ERR("check_csum returned %08x\n", Status);
